/***********************************************************************
 Name             : ExampleData.java
 Autor            : Marcel Lattmann
                    Eidgenoessisch Technische Hochschule Zuerich (ETHZ)
 Letzte Aenderung : 22.7.1999

 Erzeugt zufaellige Daten und legt sie als Matrix.
 
 Benoetigt folgende Klassen:

 History:
************************************************************************/


import java.lang.*;

public class ExampleData {

  // Matrix fuer die erzeugten Werte
  Matrix v;

  public ExampleData(int x1,int y1,int x2,int y2) {
    /* Konstruktor fuer zufaellige Datenmengen. Die Daten liegen im Bereich
       zwischen (x1,x2) und (y1,y2) */
		
    int i,j;
    double xmax, xmin, ymax, ymin;
    double offsetx, offsety, scalex, scaley;

    // Anzahl Werte
    int size = (int) (Math.random() * 15) + 3;
    v = new Matrix(size,2);

    double b = Math.random()*2;
    double c = Math.random()*.05;
    double d = Math.random()*0.05-0.025;
    double e = Math.random()*0.05-0.025;
    
    double coeff = Math.random()*3+1;
    double x = 0;
    double y = 0;
    double yy = 0;
    for (i = 0; i < v.zeilen; i++) {
      j = (i+1)*(int)coeff;
      v.element[i][0] = Math.abs(Math.random()*10-5+Math.pow(c*j,2)+(b+Math.random()*0.5-0.25)*j);
      y = Math.abs(j + Math.random()*4-2);
      v.element[i][1] = y + e*Math.pow(x,2) + d*Math.pow(x,3);
    }

    // Wertebereiche ermitteln;
    xmin=xmax=v.element[0][0];
    ymin=ymax=v.element[0][1];
    for (i = 1; i < v.zeilen; i++) {
      if (v.element[i][0] < xmin){
        xmin = v.element[i][0];
      } else if (v.element[i][0] > xmax) {
        xmax = v.element[i][0];
      }
      if (v.element[i][1] < ymin) {
        ymin = v.element[i][1];
      } else if (v.element[i][1] > ymax) {
        ymax = v.element[i][1];
      }
    }

    // Werte normieren
    scalex = (x2-x1-0.1)/(xmax - xmin);
    scaley = (y2-y1-0.1)/(ymax - ymin);
    for (i = 0; i < v.zeilen; i++) {
      v.element[i][0] = scalex*(v.element[i][0]-xmin);
      v.element[i][1] = scaley*(v.element[i][1]-ymin);
    }
  }

  public ExampleData(int i) {
  // Lade eine von 4 Beispieldateien
    if (i==1) {
      String example="1,0.536; 2,0.598; 3,0.62; 4,1.044; 5,6.719; 6,8.869; 7,9.332; 8,9.485;";
             example=example+"9,9.579; 10,9.668";
      v = new Matrix(example);
    } else if (i==2) {
     String example="-10,3.17; -9,3.77; -8,3.68; -7,1.81; -6,2.81; -5,2.89;";
    example=example+"-4,3.86; -3,4.34; -2,5.32; -1,5.39;  0,7.68";
      v = new Matrix(example);
    } else if (i==3) {
      String example="-9.21, 0.536; -8.11,0.598; -6.91,0.320; -5.81,1.044;";
     example=example+"-4.61,6.719; -3.51,8.869; -2.30,9.332; -1.20,9.485;";
     example=example+" 0,9.579;  2.30,9.468";
      v = new Matrix(example);
    } else {
      String example="1,-1;2,-4;3,-9";
      v = new Matrix(example);
    }
  }
}

